unit UFormConsole;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  UMachine;

type

  { TFormConsole }

  TFormConsole = class(TForm)
    Memo1: TMemo;
    Timer1: TTimer;
    procedure Memo1KeyPress(Sender: TObject; var Key: char);
    procedure Timer1Timer(Sender: TObject);
  private

  public
    Machine: TMachine;
  end;

var
  FormConsole: TFormConsole;

implementation

{$R *.lfm}

{ TFormConsole }

procedure TFormConsole.Memo1KeyPress(Sender: TObject; var Key: char);
begin
  Machine.LockInput.Acquire;
  Machine.InputBuffer := Machine.InputBuffer + Key;
  Machine.LockInput.Release;
end;

procedure TFormConsole.Timer1Timer(Sender: TObject);
begin
  Machine.LockOutput.Acquire;
  Memo1.Lines.Text := Memo1.Lines.Text + Machine.OutputBuffer;
  SetLength(Machine.OutputBuffer, 0);
  Machine.LockOutput.Release;
end;

end.

